package boardgame

import defs.*

object BoardGame:

  extension (wm: WorldMap)
    // Warm-up
    def tile(x: BigInt, y: BigInt): Tile =
      require(0 <= y && y < wm.height)
      ???

  //////////////////////////////////////////////////////////////////////

  extension (tile: Tile)
    // Task 1
    def yields: Yields =
      ???

  extension (base: BaseTerrain)
    def yieldsTerrain: Yields =
      ???

  extension (ft: Feature)
    def yieldsFeature(base: Option[BaseTerrain]): Yields =
      ???

  extension (res: Resource)
    def yieldsResource: Yields =
      ???

  extension (improv: ResourceImprovement)
    def yieldsImprovement: Yields =
      ???

  //////////////////////////////////////////////////////////////////////

  // Task 2
  def adjacencyBonus(wm: WorldMap, x: BigInt, y: BigInt): BigInt =
    require(0 <= y && y < wm.height)
    require(wm.width > 4)
    ???

  //////////////////////////////////////////////////////////////////////

  // Task 3
  def validCitySettlement(wm: WorldMap, x: BigInt, y: BigInt): Boolean =
    require(0 <= y && y < wm.height)
    require(wm.width > 4)
    ???

  // Task 3a
  def collectTilesInRing(wm: WorldMap, x: BigInt, y: BigInt, radius: BigInt): List[Tile] =
    require(0 <= y && y < wm.height)
    require(radius >= 0)
    // To avoid repetition of tiles due to wrapping
    require(2 * radius < wm.width)
    ???

  // Task 3b
  def allTilesWithinRadius(wm: WorldMap, x: BigInt, y: BigInt, radius: BigInt): List[Tile] =
    require(0 <= y && y < wm.height)
    require(radius >= 0)
    // To avoid repetition of tiles due to wrapping
    require(2 * radius < wm.width)
    ???

  // Task 3c
  def noOtherCitiesInRange(wm: WorldMap, x: BigInt, y: BigInt): Boolean =
    require(0 <= y && y < wm.height)
    require(wm.width > 4)
    ???
