package patmat

final class BSTException extends Exception

enum BSTContext:
  case Leaf
  case Branch(k: Int, v: String, l: BSTContext, r: BSTContext)

  def isLeaf: Boolean = this match
    case Leaf      => true
    case _: Branch => false

  def key: Int =
    require(this.isInstanceOf[Branch])
    this match
      case Leaf               => throw BSTException()
      case Branch(k, v, l, r) => k

  def value: String =
    require(this.isInstanceOf[Branch])
    this match
      case Leaf               => throw BSTException()
      case Branch(k, v, l, r) => v

  def left: BSTContext =
    require(this.isInstanceOf[Branch])
    this match
      case Leaf               => throw BSTException()
      case Branch(k, v, l, r) => l

  def right: BSTContext =
    require(this.isInstanceOf[Branch])
    this match
      case Leaf               => throw BSTException()
      case Branch(k, v, l, r) => r

enum FindResult:
  case Found(value: String)
  case NotFound
