package prime

object Prime:
  /** @param n
    *   An integer
    * @return
    *   ⌊√(n)⌋
    */
  def isqrt(n: BigInt): BigInt =
    require(n > 0)
    def loop(n: BigInt, i: BigInt): BigInt =
      require(n >= 0 && i > 0 && i <= n)
      if i == n / i then i
      else if i > n / i then i - 1
      else loop(n, i + 1)
    loop(n, 1)

  /** @param n
    *   A natural number
    * @return
    *   Boolean about the primality of the given natural number n
    */
  def isPrime(n: BigInt): Boolean =
    require(n >= 0)
    ???
