/* Copyright 2022 EPFL, Lausanne */
/* Written in Pure Scala in order to be compatible for Stainless */
/* https://epfl-lara.github.io/stainless/purescala.html */

package drop

object DropSuiteIO:
  sealed abstract class Tests
  case class DropWorksOnSimpleCase(ls: List[Int], n: Int, exp: List[Int], points: Int) extends Tests
  case class DropThrowsException(ls: List[Int], n: Int, points: Int) extends Tests

  val allTests: Array[Tests] =
    Array(
      DropThrowsException(Nil, -1, 10),
      DropWorksOnSimpleCase(Nil, 5, Nil, 10),
      DropWorksOnSimpleCase(4 :: 8 :: Nil, 2, 4 :: Nil, 10),
      DropWorksOnSimpleCase(4 :: 8 :: Nil, 3, 4 :: 8 :: Nil, 10),
      DropWorksOnSimpleCase(4 :: 8 :: 7 :: Nil, 3, 4 :: 8 :: Nil, 10),
      DropWorksOnSimpleCase(4 :: 8 :: 3 :: Nil, 0, 4 :: 8 :: 3 :: Nil, 10),
      DropWorksOnSimpleCase(4 :: 8 :: 7 :: 5 :: 4 :: 3 :: Nil, 3, 4 :: 8 :: 5 :: 4 :: Nil, 10),
      DropWorksOnSimpleCase(3 :: 7 :: 5 :: Nil, 2, 3 :: 5 :: Nil, 10),
      DropWorksOnSimpleCase(3 :: 1 :: 4 :: 2 :: Nil, 2, 3 :: 4 :: Nil, 10),
      DropWorksOnSimpleCase(
        3 :: 7 :: 5 :: 1 :: 7 :: 6 :: 4 :: 8 :: 2 :: 1 :: 6 :: 5 :: 5 :: 4 :: 8 :: 9 :: 6 :: Nil,
        4,
        3 :: 7 :: 5 :: 7 :: 6 :: 4 :: 2 :: 1 :: 6 :: 5 :: 4 :: 8 :: 6 :: Nil,
        10
      ),
      DropWorksOnSimpleCase(
        3 :: 7 :: 5 :: 1 :: 7 :: 6 :: 4 :: 8 :: 2 :: 1 :: 6 :: 5 :: 5 :: 4 :: 8 :: 9 :: 6 :: Nil,
        1,
        Nil,
        10
      )
    )
