import patmat.*

import BSTContext.*
import BSTOpsBasic.*
import BSTOpsRotate.*
import FindResult.*

class BSTOpsTest extends munit.FunSuite:
  test("lookup: singleton tree"):
    assertEquals(lookup(Branch(0, "a", Leaf, Leaf), 0), Found("a"))
    assertEquals(lookup(Branch(0, "a", Leaf, Leaf), 1), NotFound)

  test("lookup: simple tree"):
    val tree = Branch(
      0,
      "b",
      Branch(-1, "a", Leaf, Leaf),
      Branch(2, "d", Branch(1, "c", Leaf, Leaf), Branch(3, "e", Leaf, Leaf))
    )
    assertEquals(lookup(tree, -1), Found("a"))
    assertEquals(lookup(tree, 0), Found("b"))
    assertEquals(lookup(tree, 1), Found("c"))
    assertEquals(lookup(tree, 2), Found("d"))
    assertEquals(lookup(tree, 3), Found("e"))
    assertEquals(lookup(tree, 4), NotFound)
    assertEquals(lookup(tree, -2), NotFound)

  test("insert: singleton tree"):
    val tree = Branch(0, "a", Leaf, Leaf)
    assertEquals(insert(tree, 1, "b"), Branch(0, "a", Leaf, Branch(1, "b", Leaf, Leaf)))
    assertEquals(insert(tree, -1, "b"), Branch(0, "a", Branch(-1, "b", Leaf, Leaf), Leaf))
    assertEquals(insert(tree, 0, "b"), Branch(0, "b", Leaf, Leaf))
